SystemOrganization addCategory: #'Ma time objects-Info'!
SystemOrganization addCategory: #'Ma time objects-Kernel'!
SystemOrganization addCategory: #'Ma time objects-Tests'!

!Float methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 13:42'!
maSeconds
	"Return an MaDuration (to be used as a magnitude) with a magnitude of the number of seconds the receiver represents."
	| trunc| trunc := self truncated.
	^ trunc maSeconds + (self-trunc*1000) truncated maMilliseconds! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:17'!
maDay

	^self maDays
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 10:49'!
maDays

	^MaDuration fromSeconds: self * MaCalendarTime secondsPerDay! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 2/2/2003 10:10'!
maDivideIntoCalendarTime: aMaDuration

	^MaDuration fromMilliseconds: aMaDuration totalMilliseconds // self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 2/2/2003 10:34'!
maDivideIntoDuration: aMaDuration

	^MaDuration fromMilliseconds: aMaDuration totalMilliseconds // self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:15'!
maHour

	^self maHours
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:04'!
maHours

	^MaDuration fromSeconds: self * 3600 "seconds in an hour"! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:15'!
maMillisecond
	"Return an MaDuration (to be used as a magnitude) with
	a magnitude of the number of milliseconds the receiver represents."

	^self maMilliseconds! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:10'!
maMilliseconds
	"Return an MaDuration (to be used as a magnitude) with
	a magnitude of the number of milliseconds the receiver represents."

	^MaDuration fromMilliseconds: self! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:21'!
maMinute

	^ self maMinutes! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 13:21'!
maMinutes

	^MaDuration fromSeconds: self * 60
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 8/24/2004 13:30'!
maSecond

	^self maSeconds
! !

!Integer methodsFor: '*ma time objects' stamp: 'cmm 3/3/2004 12:58'!
maSeconds
	"Return an MaDuration (to be used as a magnitude) with a magnitude of the number of seconds the receiver represents."

	^MaDuration fromSeconds: self! !

PackageInfo subclass: #MaTimeObjectsPackageInfo
	instanceVariableNames: 'maCalendarTime maDays dateAndTime days session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Info'!

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 21:59'!
addBench
	self session commit: [ self session root add: { MagmaCollection new.  MagmaDictionary new }]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 20:38'!
benchRepositoryName
	^ '_ma-time-bench.magma'! !

!MaTimeObjectsPackageInfo methodsFor: 'documenting' stamp: 'cmm 7/13/2011 21:19'!
benchmarkReport
	"self new benchmarkReport"
	^ String streamContents:
		[ : stream | self printBenchmarkReportOn: stream ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 22:25'!
close
	session ifNotNil: [ session disconnectAndClose ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 15:35'!
createTestRepository
	(Smalltalk at: #MagmaRepositoryController) in:
		[ : mrc | | loc mc md |
		loc := (Smalltalk at: #MagmaLocalLocation) path: self benchRepositoryName.
		loc isMagmaRepository ifTrue:
			[ [ loc delete ]
				on: (Smalltalk classNamed: #MagmaDeleteWarning)
				do:
					[ : warning | warning resume ] ].
		mc := Smalltalk classNamed: #MagmaCollection.
		md := Smalltalk classNamed: #MagmaDictionary.
		mrc
			create: self benchRepositoryName
			root:
				(OrderedCollection
					with: {mc new. 
						mc new}
					with: {md new. 
						md new}) ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 14:41'!
durationToAccessLotsOf: aClass from: aMaDictionary 
	^ [ self
		first: 100000
		random: aClass
		withIndexDo:
			[ : eachDate : x | self assert: (aMaDictionary includesKey: eachDate) ] ] durationToRun! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 13:39'!
durationToAddLotsOf: aClass to: container
	self session begin.
	^ [
	self
		first: 100000
		random: aClass
		withIndexDo:
			[ : eachDate : x | container add: eachDate.
			x \\ 1000 = 0 ifTrue: [ self session commitAndBegin ] ].
	self session commit ] durationToRun! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 22:43'!
durationToEnumerate: aMagmaCollection 
	^ [ aMagmaCollection do:
		[ : each | each yourself ] ] durationToRun! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 22:23'!
durationToPutLotsOf: aClass 
	| coll |
	coll := self session root last second.
	^ [ self session begin.
	self
		first: 100000
		random: aClass
		withIndexDo:
			[ : eachDate : x | coll at: eachDate put: nil.
			x \\ 1000 = 0 ifTrue: [ self session commitAndBegin ] ].
	self session commit ] durationToRun! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 13:40'!
durationToPutLotsOf: aClass into: container
	self session begin.
	^ [ self
		first: 100000
		random: aClass
		withIndexDo:
			[ : eachDate : x | container at: eachDate put: nil.
			x \\ 1000 = 0 ifTrue: [ self session commitAndBegin ] ].
	self session commit ] durationToRun! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 22:15'!
first: count random: dateClass withIndexDo: twoArgBlock 
	| r |
	r := self random.
	1
		to: count
		do:
			[ : n | 
			twoArgBlock
				value: (dateClass fromSeconds: (r nextInt: 3488131789))
				value: n ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 21:15'!
localSession
	^ (MagmaLocalLocation path: self benchRepositoryName) newSession
		 connectAs: 'date bench' ;
		 yourself! !

!MaTimeObjectsPackageInfo methodsFor: 'private' stamp: 'cmm 7/13/2011 20:49'!
pit: firstFixture against: secondFixture for: selector 
	^ [ firstFixture perform: selector ] bench -> [ secondFixture perform: selector ] bench! !

!MaTimeObjectsPackageInfo methodsFor: 'private' stamp: 'cmm 7/13/2011 21:28'!
pit: firstFixture using: firstArgs against: secondFixture using: secondArgs for: selector 
	^ [ firstFixture
		perform: selector
		with: firstArgs ] bench ->
		[ secondFixture
			perform: selector
			with: secondArgs ] bench! !

!MaTimeObjectsPackageInfo methodsFor: 'private' stamp: 'cmm 7/15/2011 15:33'!
printBenchmarkReportOn: aStream 
	"Bench the most critical operations of this package against corresponding operations of standard Chronology.  Use two Chronology objects for each bench, one in the local time and the other in UTC, because this can have a huge impact on Chronology performance."
	self setupBench.
	self specsAndTimingsDo:
		[ : eachSpecArray : eachMeasurements | aStream
			 cr ;
			 nextPutAll: eachSpecArray first ;
			 tab ;
			 tab ;
			 print: eachMeasurements ].
	(Smalltalk hasClassNamed: #MagmaRepositoryController) ifTrue: [ self printMagmaBenchOn: aStream ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 15:35'!
printMagmaBenchOn: aStream 
	| oldSetting |
	aStream
		 cr ;
		 cr ;
		 nextPutAll: 'Magma tests:' ;
		 cr ;
		 flush.
	[ oldSetting := (Smalltalk classNamed: #MagmaPreferences) showStatusViaCursor.
	(Smalltalk classNamed: #MagmaPreferences) showStatusViaCursor: false.
	self
		 createTestRepository ;
		 runBenchPrintOn: aStream ] ensure:
		[ self close.
		(Smalltalk classNamed: #MagmaPreferences) showStatusViaCursor: oldSetting ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/14/2011 21:19'!
random
	^ Random seed: 20110714! !

!MaTimeObjectsPackageInfo methodsFor: 'documenting' stamp: 'cmm 7/14/2011 22:09'!
readmeText
	^'MaTimeObjects is a lightweight alternative to Chronology.  Each type of object in the package is nothing more than an Integer, which affords some improved storage efficiencies for large-scale systems.

The core domain class is MaCalendarTime, which can represent either a point on the Gregorian calendar, or a duration of time (e.g., seconds, days, etc.).

To get the current time, precise to the millisecond:

	MaCalendarTime now

To obtain a duration:

	3 maMinutes

A variety of arithmetic is supported:

	3 maMinutes + 2 maSeconds
	8 maHours // 2
	(1 maHour + 27  maMinutes) roundTo: 30 maMinutes
	MaCalendarTime now - 30 maDays
	MaCalendarTime now - (MaCalendarTime fromString: ''1969/12/31 23:52:59.999'')

MaStopwatch
This is just, a stopwach like you would use in real life.  Precise tothe millisecond and a very simple, terse api.

	MaStopwatch new start
'! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 13:49'!
runBenchPrintOn: aStream 
	{DateAndTime. 
	MaCalendarTime} withIndexDo:
		[ : each : x | 
		aStream cr; tab;
			 nextPutAll: 'Time to add 100000 ' ;
			 nextPutAll: each name ;
			 print: '''s into a MagmaCollection:  ' ;
			 print: (self durationToAddLotsOf: each to: (self session root first at: x)); flush ].
	{DateAndTime. 
	MaCalendarTime} withIndexDo:
		[ : each : x | 
		aStream cr; tab;
			 nextPutAll: 'Time to put 100000 ' ;
			 nextPutAll: each name ;
			 print: '''s into a MagmaDictionary:  ' ;
			 print: (self durationToPutLotsOf: each into: (self session root last at: x)); flush ].
	{DateAndTime. 
	MaCalendarTime} withIndexDo:
		[ : each : dateClassIndex | | mc |
		mc := self session root first at: dateClassIndex.
		aStream cr; tab;
			 nextPutAll: 'Time to enumerate 100000 ' ;
			 nextPutAll: each name ;
			 print: '''s in a MagmaCollection  ' ;
			 print: (self durationToEnumerate: mc); flush ].
	{DateAndTime. 
	MaCalendarTime} withIndexDo:
		[ : each : dateClassIndex | | md |
		md := self session root second at: dateClassIndex.
		aStream cr; tab;
			 nextPutAll: 'Time to access 100000 ' ;
			 nextPutAll: each name ;
			 print: '''s in a MagmaDictionary  ' ;
			 print: (self durationToAccessLotsOf: each from: md);
			 flush ].! !

!MaTimeObjectsPackageInfo methodsFor: 'private-magma bench' stamp: 'cmm 7/15/2011 15:32'!
session
	^ session ifNil:
		[ session := ((Smalltalk classNamed: #MagmaLocalLocation) path: self benchRepositoryName) newSession
			 connectAs: 'date bench' ;
			 yourself ]! !

!MaTimeObjectsPackageInfo methodsFor: 'private' stamp: 'cmm 7/13/2011 21:42'!
setupBench
	maCalendarTime := (dateAndTime := DateAndTime now makeUTC) asMaCalendarTime.
	maDays := 3 maDays.
	days := 3 days! !

!MaTimeObjectsPackageInfo methodsFor: 'private' stamp: 'cmm 7/13/2011 21:34'!
specsAndTimingsDo: twoArgBlock 
	|specs| 
	specs:=
	{{#now. MaCalendarTime. DateAndTime}.
	{#asDate. maCalendarTime. dateAndTime}.
	{#asHour. maCalendarTime. dateAndTime}.
	{#asMinute. maCalendarTime. dateAndTime}.
	{#asMonth. maCalendarTime. dateAndTime}.
	{#asQuarter. maCalendarTime. dateAndTime}.
	{#asWeek. maCalendarTime. dateAndTime}.
	{#asYear. maCalendarTime. dateAndTime}.
	{#hash. maCalendarTime. dateAndTime}.
	{#=. maCalendarTime. maCalendarTime. dateAndTime. dateAndTime }.
	{#+. maCalendarTime. maDays. dateAndTime. days}.
	{#-. maCalendarTime. maDays. dateAndTime. days}.
	 }.
	'Running benchmarks...' 
		displayProgressAt: Display center 
		from: 1 
		to: specs size 
		during: 
			[ : bar |
			specs withIndexDo:
				[ : each : x | twoArgBlock
					value: each
					value:
						(each first isUnary
							ifTrue:
								[ self
									pit: each second
									against: each third
									for: each first ]
							ifFalse:
								[ self
									pit: each second
									using: each third
									against: each fourth
									using: each fifth
									for: each first ]).
				bar value: x ] ]! !

!Delay class methodsFor: '*ma time objects' stamp: 'cmm 12/19/2002 23:38'!
for: aMaCalendarTime
	"Example:
		(Delay for: 10 seconds) wait"

	^self forMilliseconds: aMaCalendarTime totalMilliseconds! !

!Duration methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 15:26'!
asMaCalendarTime
	^ MaDuration fromMilliseconds: self asMilliseconds! !

!Duration methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 15:27'!
asMaDuration
	^ self asMaCalendarTime! !

!Duration methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 15:54'!
maDivideIntoDuration: aMaCalendarTime 
	^ self asMaCalendarTime maDivideIntoDuration: aMaCalendarTime! !

!BlockContext methodsFor: '*ma time objects' stamp: 'cmm 12/5/2002 21:46'!
maCalendarTimeToRun

	| start |
	start := MaCalendarTime now.
	self value.
	^MaCalendarTime now - start! !

Magnitude subclass: #MaCalendarTime
	instanceVariableNames: 'totalMilliseconds'
	classVariableNames: 'BaseCalendarDate FirstRecordedMillisecondClock FirstTimestampMillisecond'
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaCalendarTime commentStamp: '<historical>' prior: 0!
I represent a calendar time; either a duration represented in units of a Gregorian calendar (days, hours, minutes, seconds, etc.) or a point on the timeline of the Gregorian calendar.

I support full arithmetic with other CalendarTimes and Integers as it makes sense.  For example, dividing 30 minutes by 3 makes sense, but not May 19th, 1969.

I have fairly efficient storage, a single integer of the total number of milliseconds that have elapsed since my base time, 1/1/1901 @ 12:00am.
!

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 7/13/2011 19:58'!
date: aDate 
	^ self fromSeconds: aDate asSeconds! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:40'!
date: aDate time: aTime

	^self fromSeconds: aDate asSeconds + aTime asSeconds
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:50'!
date: aDate time: aTime milliseconds: anInteger

	^self fromMilliseconds: (aDate asSeconds + aTime asSeconds) * 1000 + anInteger
! !

!MaCalendarTime class methodsFor: 'private' stamp: 'cmm 7/15/2011 16:07'!
differenceBetween: firstMaCalendarTime and: secondMaCalendarTime 
	^ self fromMilliseconds: firstMaCalendarTime totalMilliseconds - secondMaCalendarTime totalMilliseconds! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:51'!
epoch
	"Return a new instance of the receiver with its time set to 0.
	This is useful for timing operations."

	^self fromMilliseconds: 0
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 7/10/2011 22:59'!
fromDays: anInteger 
	^ self fromMilliseconds: 24 * 60 * 60 * 1000 * anInteger! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:44'!
fromMilliseconds: anInteger

	^self new totalMilliseconds: anInteger
! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 7/8/2011 22:22'!
fromSeconds: anInteger 
	"Returns a new instance of the receiver based on anInteger seconds."
	^ self fromMilliseconds: anInteger * 1000! !

!MaCalendarTime class methodsFor: 'initializing' stamp: 'cmm 7/9/2011 16:34'!
initialize
	Smalltalk addToStartUpList: self.
	FirstRecordedMillisecondClock := Time millisecondClockValue.
	FirstTimestampMillisecond := Date today asSeconds * 1000 + (Time now asNanoSeconds // 1000000).
	BaseCalendarDate := DateAndTime epoch asDate! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 7/15/2011 17:11'!
new
	^ super new totalMilliseconds: 0! !

!MaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:51'!
now
	"answer a new timestamp for the current date and time."

	^self fromMilliseconds:
		(Time millisecondClockValue - FirstRecordedMillisecondClock + FirstTimestampMillisecond)
! !

!MaCalendarTime class methodsFor: 'private' stamp: 'cmm 3/6/2002 22:13'!
secondsPerDay

	^86400
! !

!MaCalendarTime class methodsFor: 'initializing' stamp: 'cmm 12/16/2005 16:33'!
startUp
	super startUp.
	self initialize! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/28/2005 21:39'!
+ aMaCalendarTime

	^self species fromMilliseconds: totalMilliseconds + aMaCalendarTime totalMilliseconds! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 7/15/2011 16:05'!
- aMaCalendarTime 
	^ ((self species = aMaCalendarTime species or:
		[ (self isMaTimespan) and: [ aMaCalendarTime isMaTimespan ] ])
		ifTrue: [ MaDuration ]
		ifFalse: [ self class ])
			differenceBetween: self
			and: aMaCalendarTime! !

!MaCalendarTime methodsFor: 'comparing' stamp: 'cmm 3/6/2002 23:29'!
< aMaCalendarTime

	^self totalMilliseconds < aMaCalendarTime totalMilliseconds
! !

!MaCalendarTime methodsFor: 'comparing' stamp: 'cmm 3/28/2005 21:40'!
= aMaCalendarTime 
	aMaCalendarTime species = self species ifFalse: [^false].
	^self totalMilliseconds = aMaCalendarTime totalMilliseconds! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:20'!
asDate
	^ MaDate spanning: self! !

!MaCalendarTime methodsFor: 'converting' stamp: 'cmm 7/13/2011 20:47'!
asDateAndTime
	"Answer a Chronology DateAndTime."
	^ (DateAndTime fromSeconds: self totalMilliseconds / 1000.0) makeUTC! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:21'!
asHour
	^ MaHour spanning: self! !

!MaCalendarTime methodsFor: 'converting' stamp: 'cmm 7/9/2011 15:27'!
asMaCalendarTime
	^ self! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:22'!
asMinute
	^ MaMinute spanning: self! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:22'!
asMonth
	^ MaMonth spanning: self! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:22'!
asQuarter
	^ MaQuarter spanning: self! !

!MaCalendarTime methodsFor: 'converting' stamp: 'cmm 7/10/2011 17:27'!
asTime
	^ Time
		seconds: self totalSeconds
		nanoSeconds: self millisecond * 1000000! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:20'!
asWeek
	^ MaWeek spanning: self! !

!MaCalendarTime methodsFor: 'converting - timespans' stamp: 'cmm 7/10/2011 17:07'!
asYear
	^ MaYear spanning: self! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 23:44'!
dayOfMonth
	"The julian day for the year."
	^ self asDateAndTime dayOfMonth! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/11/2011 19:53'!
dayOfWeek
	"Sunday=1, ... , Saturday=7"
	^ self totalDays+2 \\ 7 + 1! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/12/2011 20:28'!
dayOfYear
	"The julian day for the year."
	^ (self - self asYear) totalDays + 1! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/11/2011 20:01'!
daysInMonth
	^ self asDateAndTime in:
		[ : dt | Month
			daysInMonth: dt monthIndex
			forYear: dt year ]! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/11/2011 20:03'!
daysInYear
	^ self asDateAndTime daysInYear! !

!MaCalendarTime methodsFor: 'comparing' stamp: 'cmm 2/2/2003 10:42'!
hash

	^self totalMilliseconds hash! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:38'!
hour
	^ self totalSeconds // 3600 \\ 24! !

!MaCalendarTime methodsFor: 'testing' stamp: 'cmm 7/15/2011 16:19'!
isZero
	^ self totalMilliseconds isZero! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:27'!
millisecond
	^ self totalMilliseconds \\ 1000! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:37'!
minute
	^ self totalSeconds // 60 \\ 60! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:22'!
month
	^ self asDateAndTime monthIndex! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/11/2011 22:13'!
monthName
	^ Month nameOfMonth: self month! !

!MaCalendarTime methodsFor: 'printing' stamp: 'cmm 7/13/2011 22:03'!
printAbbreviatedOn: aStream 
	aStream print: self asDateAndTime makeUTC! !

!MaCalendarTime methodsFor: 'printing' stamp: 'cmm 7/15/2011 17:00'!
printOn: aStream 
	super printOn: aStream.
	aStream space.
	self printAbbreviatedOn: aStream! !

!MaCalendarTime methodsFor: 'printing' stamp: 'cmm 7/8/2011 23:00'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^ self printStringLimitedTo: 50000! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:22'!
quarter
	^ self asDateAndTime quarter! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 7/9/2011 11:53'!
roundTo: aMaDuration 
	"Answer a MaCalendarTime rounded to the nearest aMaDuration.
	For example, if the receiver is 5 minutes, 37 seconds, and aMaDuration is 2 minutes, then return 6 minutes."
	^ self species fromMilliseconds: (self totalMilliseconds roundTo: aMaDuration totalMilliseconds)! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:33'!
second
	^ self totalSeconds \\ 60! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/13/2011 18:18'!
start
	^ self! !

!MaCalendarTime methodsFor: 'converting' stamp: 'cmm 3/28/2005 21:40'!
totalDays

	^self totalSeconds // self species secondsPerDay
! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/15/2011 16:01'!
totalMilliseconds
	"The total number of milliseconds elapsed since my epoch."
	^totalMilliseconds! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/15/2011 16:00'!
totalMilliseconds: anInteger 
	totalMilliseconds := anInteger! !

!MaCalendarTime methodsFor: 'converting' stamp: ''!
totalSeconds

	^self totalMilliseconds // 1000
! !

!MaCalendarTime methodsFor: 'operators' stamp: 'cmm 7/9/2011 11:54'!
truncateTo: aMaDuration 
	"Answer a new MaCalendarTime that is truncated to the nearest aMaDuration.  For example, if the receiver is 5 minutes, 37 seconds, and duration is 2 minutes, then return 4 minutes."
	^ self species fromMilliseconds: (self totalMilliseconds truncateTo: aMaDuration totalMilliseconds)! !

!MaCalendarTime methodsFor: 'accessing' stamp: 'cmm 7/10/2011 17:07'!
year
	^ self asDateAndTime year! !

MaCalendarTime subclass: #MaDuration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaDuration commentStamp: 'cmm 7/12/2011 20:34' prior: 0!
A MaDuration represents a duration of time.  It is API and implementation-interchangable with instances of MaCalendarTime.

MaDurations may be created either with the #fromMilliseconds: constructor method or, for greater readability:

	1 maDay + 2 maHours + 3 maMinutes + 4 maSeconds + 5 maMilliseconds!

!MaDuration class methodsFor: 'as yet unclassified' stamp: 'cmm 7/12/2011 20:26'!
zero
	^ self epoch! !

!MaDuration methodsFor: 'operators' stamp: 'cmm 3/28/2005 21:49'!
* anInteger

	^self species fromMilliseconds: self totalMilliseconds * anInteger! !

!MaDuration methodsFor: 'operators' stamp: 'cmm 2/2/2003 10:35'!
// anIntegerOrCalendarTime

	^anIntegerOrCalendarTime maDivideIntoDuration: self! !

!MaDuration methodsFor: 'operators' stamp: 'cmm 7/15/2011 16:28'!
\\ aMaDuration 
	^ self class fromMilliseconds: self totalMilliseconds \\ aMaDuration totalMilliseconds! !

!MaDuration methodsFor: 'private' stamp: 'cmm 7/9/2011 15:14'!
maDivideIntoDuration: aMaCalendarTime 
	^ aMaCalendarTime totalMilliseconds // self totalMilliseconds! !

!MaDuration methodsFor: 'printing' stamp: 'cmm 7/15/2011 16:25'!
printOn: aStream 
aStream
		 nextPutAll: 'a ' ;
		 print: self class; space.
	self totalSeconds >= self species secondsPerDay ifTrue:
		[ aStream
			 print: (self asDateAndTime asDate subtractDate: BaseCalendarDate) ;
			 nextPutAll: ' days, ' ].
	self asTime
		print24: true
		on: aStream! !

MaCalendarTime subclass: #MaTimespan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaTimespan commentStamp: 'cmm 7/10/2011 23:48' prior: 0!
A MaTimespan represents a span of time on the calendar.!

MaTimespan subclass: #MaDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaDate commentStamp: 'cmm 7/10/2011 23:46' prior: 0!
A MaDate represents one calendary day.!

!MaDate class methodsFor: 'create' stamp: 'cmm 7/13/2011 19:59'!
date: aDate
	^ super date: aDate! !

!MaDate class methodsFor: 'overriding' stamp: 'cmm 7/9/2011 17:26'!
duration
	^ 1 maDay! !

!MaDate class methodsFor: 'create' stamp: 'cmm 7/11/2011 20:32'!
today
	^ self date: Date today! !

!MaDate methodsFor: 'printing' stamp: 'cmm 7/13/2011 20:11'!
printAbbreviatedOn: aStream
	self asDateAndTime asDate printOn: aStream! !

MaTimespan subclass: #MaHour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaHour commentStamp: 'cmm 7/10/2011 23:47' prior: 0!
A MaHour represents a 60-minute period starting on a particular hour.!

!MaHour class methodsFor: 'overriding' stamp: 'cmm 7/9/2011 17:05'!
duration
	^ 1 maHour! !

!MaHour methodsFor: 'printing' stamp: 'cmm 7/13/2011 20:11'!
printAbbreviatedOn: aStream 
	self asDateAndTime
		printYMDOn: aStream
		withLeadingSpace: false.
	aStream nextPut: $T.
	self hour
		printOn: aStream
		base: 10
		length: 2
		padded: true! !

MaTimespan subclass: #MaMinute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaMinute commentStamp: 'cmm 7/10/2011 23:47' prior: 0!
A MaMinute represents a clock minute - seconds from 0 to 60.!

!MaMinute class methodsFor: 'overriding' stamp: 'cmm 7/9/2011 17:06'!
duration
	^ 1 maMinute! !

!MaMinute methodsFor: 'printing' stamp: 'cmm 7/13/2011 20:11'!
printAbbreviatedOn: aStream 
	self asDateAndTime
		printYMDOn: aStream
		withLeadingSpace: false.
	aStream nextPut: $T.
	self hour
		printOn: aStream
		base: 10
		length: 2
		padded: true.
	aStream nextPut: $:.
	self minute
		printOn: aStream
		base: 10
		length: 2
		padded: true! !

MaTimespan subclass: #MaMonth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaMonth commentStamp: 'cmm 7/10/2011 23:47' prior: 0!
A MaMonth represents a calendar month.!

!MaMonth class methodsFor: 'creation' stamp: 'cmm 7/11/2011 22:11'!
month: monthIndexOrName year: yearInteger 
	^ (Month
		month: monthIndexOrName
		year: yearInteger) asMaCalendarTime! !

!MaMonth class methodsFor: 'overriding' stamp: 'cmm 7/15/2011 17:07'!
spanning: aMaCalendarTime
	"Answer the timespan spanning aMaCalendarTime."
	^ self fromMilliseconds: aMaCalendarTime asDateAndTime asMonth start asMaCalendarTime totalMilliseconds! !

!MaMonth methodsFor: 'accessing' stamp: 'cmm 7/11/2011 20:01'!
duration
	^ self daysInMonth maDays! !

!MaMonth methodsFor: 'printing' stamp: 'cmm 7/15/2011 17:09'!
printAbbreviatedOn: aStream 
	aStream
		 nextPutAll: self monthName ;
		 space.
	self year maPrintAbbreviatedOn: aStream! !

MaTimespan subclass: #MaQuarter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaQuarter commentStamp: 'cmm 7/10/2011 23:48' prior: 0!
A MaQuarter represents a calendar Quarter of a year.!

!MaQuarter class methodsFor: 'create' stamp: 'cmm 7/10/2011 16:49'!
quarter: anInteger 
	^ self
		quarter: anInteger
		year: Year current year! !

!MaQuarter class methodsFor: 'create' stamp: 'cmm 7/10/2011 16:48'!
quarter: quarterIndex year: yearInteger 
	"anInteger between: 1 and: 4"
	^ self starting: 
		(Month 
			month: (#(1 4 7 10 ) at: quarterIndex)
			year: yearInteger) start! !

!MaQuarter class methodsFor: 'create' stamp: 'cmm 7/15/2011 17:06'!
spanning: aMaCalendarTime 
	^ self fromMilliseconds: aMaCalendarTime asMonth totalMilliseconds! !

!MaQuarter methodsFor: 'accessing' stamp: 'cmm 7/10/2011 22:11'!
duration
	| firstMonth secondMonth |
	firstMonth := self asMonth.
	secondMonth := firstMonth next.
	^ firstMonth duration + secondMonth duration + secondMonth next duration! !

!MaQuarter methodsFor: 'printing' stamp: 'cmm 7/13/2011 20:12'!
printAbbreviatedOn: aStream 
	aStream
		 nextPutAll: 'Q' ;
		 print: self quarter ;
		 nextPutAll: '/' ;
		 print: self year! !

!MaTimespan class methodsFor: 'private' stamp: 'cmm 7/13/2011 19:39'!
differenceBetween: firstMaCalendarTime and: secondMaCalendarTime 
	^ self spanning:
		(super
			differenceBetween: firstMaCalendarTime
			and: secondMaCalendarTime)! !

!MaTimespan class methodsFor: 'subclass responsibility' stamp: 'cmm 7/11/2011 22:33'!
duration
	"Any subclass that does not override this method must override #spanning:."
	self subclassResponsibility! !

!MaTimespan class methodsFor: 'creation' stamp: 'cmm 7/11/2011 22:37'!
now
	^ self spanning: MaCalendarTime now! !

!MaTimespan class methodsFor: 'creation' stamp: 'cmm 7/15/2011 16:58'!
spanning: aMaCalendarTime
	"Answer the timespan spanning aMaCalendarTime."
	^ self fromMilliseconds: (aMaCalendarTime truncateTo: self duration) totalMilliseconds! !

!MaTimespan class methodsFor: 'creation' stamp: 'cmm 7/11/2011 20:27'!
starting: aMaCalendarTime 
	"Answer the timespan beginning at aMaCalendarTime."
	^ self spanning: aMaCalendarTime! !

!MaTimespan methodsFor: 'enumerating' stamp: 'cmm 7/13/2011 20:18'!
datesDo: aBlock 
	self
		do: aBlock
		using: #asDate! !

!MaTimespan methodsFor: 'private' stamp: 'cmm 7/13/2011 20:17'!
do: aBlock using: conversionSelector 
	^ self
		do: aBlock
		with: (self start perform: conversionSelector)! !

!MaTimespan methodsFor: 'enumerating' stamp: 'cmm 7/11/2011 21:59'!
do: aBlock with: aFirstElement 
	self
		do: aBlock
		with: aFirstElement
		when: [ : t | true ]! !

!MaTimespan methodsFor: 'private' stamp: 'cmm 7/11/2011 21:59'!
do: aBlock with: aFirstElement when: aConditionBlock

	| element end |
	element := aFirstElement.
	end := self end.
	[ element start <= end ] whileTrue:
	
	[(aConditionBlock value: element)
			ifTrue: [ aBlock value: element ].
		element := element next. ]
! !

!MaTimespan methodsFor: 'accessing' stamp: 'cmm 7/9/2011 17:27'!
duration
	"Subclasses override if necessary."
	^ self class duration! !

!MaTimespan methodsFor: 'accessing' stamp: 'cmm 7/11/2011 22:56'!
end
	^ self next start - 1 maMillisecond! !

!MaTimespan methodsFor: 'enumerating' stamp: 'cmm 7/13/2011 20:18'!
hoursDo: aBlock 
	self
		do: aBlock
		using: #asHour! !

!MaTimespan methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:35'!
includes: aMaCalendarTime 
	^ aMaCalendarTime
		between: self
		and: self end! !

!MaTimespan methodsFor: 'testing' stamp: 'cmm 7/15/2011 16:05'!
isMaTimespan
	^ true! !

!MaTimespan methodsFor: 'enumerating' stamp: 'cmm 7/13/2011 20:18'!
monthsDo: aBlock 
	self
		do: aBlock
		using: #asMonth! !

!MaTimespan methodsFor: 'accessing' stamp: 'cmm 7/11/2011 22:20'!
next
	^ self + self duration! !

!MaTimespan methodsFor: 'accessing' stamp: 'cmm 7/11/2011 22:58'!
previous
	"We rely on the fact that MaTimespans truncate the starting to the beginning of that calendar-period."
	^ self class spanning: self end - self duration - 900 maMilliseconds! !

!MaTimespan methodsFor: 'accessing' stamp: 'cmm 7/15/2011 17:04'!
start
	^ MaCalendarTime fromMilliseconds: self totalMilliseconds! !

!MaTimespan methodsFor: 'enumerating' stamp: 'cmm 7/13/2011 20:18'!
weeksDo: aBlock 
	self
		do: aBlock
		using: #asWeek! !

!MaTimespan methodsFor: 'enumerating' stamp: 'cmm 7/13/2011 20:18'!
yearsDo: aBlock 
	self
		do: aBlock
		using: #asYear! !

MaTimespan subclass: #MaWeek
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaWeek commentStamp: 'cmm 7/10/2011 23:48' prior: 0!
A MaWeek represents a 7-day period beginning at midnight on some Sunday.!

!MaWeek class methodsFor: 'overriding' stamp: 'cmm 7/9/2011 17:31'!
duration
	^ 7 maDays! !

!MaWeek class methodsFor: 'overriding' stamp: 'cmm 7/15/2011 17:06'!
spanning: aMaCalendarTime 
	"Answer the timespan spanning aMaCalendarTime."
	^ self fromMilliseconds:
		(((#(1 2 ) includes: aMaCalendarTime dayOfWeek)
			ifTrue: [ aMaCalendarTime start roundTo: self duration ]
			ifFalse: [ aMaCalendarTime start truncateTo: self duration ]) - 2 maDays) totalMilliseconds! !

!MaWeek methodsFor: 'printing' stamp: 'cmm 7/13/2011 20:12'!
printAbbreviatedOn: aStream 
	aStream nextPutAll: 'a MaWeek starting: '.
	super maPrintAbbreviatedOn: aStream! !

MaTimespan subclass: #MaYear
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaYear commentStamp: 'cmm 7/10/2011 23:48' prior: 0!
A MaYear represents a calendar year.!

!MaYear class methodsFor: 'create' stamp: 'cmm 7/15/2011 16:59'!
spanning: aMaCalendarTime 
	^ self fromMilliseconds: aMaCalendarTime asDateAndTime asCalendarYear start asMaCalendarTime totalMilliseconds! !

!MaYear class methodsFor: 'create' stamp: 'cmm 7/11/2011 22:38'!
year: yearInteger
	^ (Year year: yearInteger) asMaCalendarTime! !

!MaYear methodsFor: 'accessing' stamp: 'cmm 7/11/2011 20:03'!
duration
	^ self daysInYear maDays! !

!MaYear methodsFor: 'printing' stamp: 'cmm 7/13/2011 20:12'!
printAbbreviatedOn: aStream
	self asDateAndTime year printOn: aStream! !

!Timespan methodsFor: '*ma time objects' stamp: 'cmm 7/10/2011 22:50'!
asMaCalendarTime
	^ (Smalltalk classNamed: ('Ma' , self class name) asSymbol) starting: start asMaCalendarTime! !

!String methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 15:02'!
asMaCalendarTime
	^ self asDateAndTime asMaCalendarTime! !

!String methodsFor: '*ma time objects' stamp: 'cmm 7/10/2011 23:29'!
asMaDate
	^ self asDate asMaCalendarTime! !

!String methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 15:02'!
asMaDuration
	^ self asDuration asMaDuration! !

Object subclass: #MaStopwatch
	instanceVariableNames: 'startTime stoppedTime totalStoppedTime state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Kernel'!

!MaStopwatch commentStamp: 'cmm 7/12/2011 21:44' prior: 0!
A MaStopwatch replicates the functionality of a real-life chronograph watch.  Create a new MaStopwatch with new:

	MaStopwatch new

and it's #time will read zero.  Use my 'actions' methods to start, stop or reset the stopwatch.
!

!MaStopwatch class methodsFor: 'examples' stamp: ''!
example1

	|s|
	s := MaStopwatch new start.
	(Delay forSeconds: 3) wait.
	Transcript cr; show: s time printString.
	s reset.
	Transcript cr; show: s time printString.
! !

!MaStopwatch methodsFor: 'private' stamp: 'cmm 10/30/2002 21:24'!
beRunning

	state := #running! !

!MaStopwatch methodsFor: 'private' stamp: 'cmm 10/30/2002 22:03'!
beStopped

	state := #stopped! !

!MaStopwatch methodsFor: 'private' stamp: 'cmm 5/2/2005 22:13'!
initialize
	super initialize.
	self reset! !

!MaStopwatch methodsFor: 'testing' stamp: 'cmm 10/30/2002 22:22'!
isRunning

	^state = #running! !

!MaStopwatch methodsFor: 'testing' stamp: 'cmm 7/12/2011 21:22'!
isStarted

	^self isRunning or: [ self time > 0 maSeconds ]
! !

!MaStopwatch methodsFor: 'testing' stamp: 'cmm 10/30/2002 22:22'!
isStopped

	^state = #stopped! !

!MaStopwatch methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:32'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $ .
	self time maPrintAbbreviatedOn: aStream! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 3/3/2004 12:59'!
reset

	self beStopped.
	totalStoppedTime := 0 maSeconds.
	stoppedTime := nil.
	startTime := nil! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 1/8/2003 23:53'!
restart

	self reset; start! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 7/9/2011 17:03'!
start

	self isRunning ifTrue: [ ^self ].
	startTime
		ifNil:
			[ startTime := MaCalendarTime now.
			stoppedTime := startTime.
			totalStoppedTime := 0 maSeconds ]
		ifNotNil:
			[ totalStoppedTime := totalStoppedTime + (MaCalendarTime now - stoppedTime) ].
	self beRunning! !

!MaStopwatch methodsFor: 'accessing' stamp: ''!
startTime

	"The point in time which the receiver was started."

	^startTime
! !

!MaStopwatch methodsFor: 'actions' stamp: 'cmm 2/2/2003 11:41'!
stop

	self isRunning
		ifTrue:
			[ stoppedTime := MaCalendarTime now.
			self beStopped ].
	^stoppedTime! !

!MaStopwatch methodsFor: 'accessing' stamp: 'cmm 7/12/2011 22:13'!
stoppedTime
	"The last time I was stopped."
	^ stoppedTime! !

!MaStopwatch methodsFor: 'accessing' stamp: 'cmm 7/12/2011 21:46'!
time
	"The amount of time this stopwatch has elapsed in its started state."
	^self isRunning
		ifTrue: [ MaCalendarTime now - startTime - totalStoppedTime ]
		ifFalse:
			[ startTime
				ifNil: [ 0 maSeconds ]
				ifNotNil: [ stoppedTime - startTime - totalStoppedTime ] ]! !

!MaStopwatch methodsFor: 'accessing' stamp: 'cmm 7/12/2011 22:13'!
totalStoppedTime
	"The cumulative amount of time since I was first started, that I have been stopped."
	^ totalStoppedTime! !

!MaStopwatch methodsFor: 'private' stamp: ''!
totalStoppedTime: anInteger

	"Set the totalStoppedTime to anInteger number of milliseconds."

	totalStoppedTime := anInteger
! !

!Object methodsFor: '*ma time objects' stamp: 'cmm 7/15/2011 16:31'!
isMaTimespan
	^ false! !

!DateAndTime methodsFor: '*ma time objects' stamp: 'cmm 7/9/2011 15:36'!
asMaCalendarTime
	^ (MaCalendarTime fromSeconds: self asSeconds) + (self nanoSecond // 1000000) maMilliseconds! !

!DirectoryEntry methodsFor: '*ma time objects' stamp: 'cmm 3/11/2003 23:39'!
maCreationTime

	^MaCalendarTime fromSeconds: creationTime! !

!DirectoryEntry methodsFor: '*ma time objects' stamp: 'cmm 3/11/2003 23:41'!
maModificationTime

	^MaCalendarTime fromSeconds: modificationTime! !

TestCase subclass: #MaTimeObjectsTest
	instanceVariableNames: 'sixMinutes twoMinutes yesterday today'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaTimeObjectsTest methodsFor: 'setUp / tearDown' stamp: 'cmm 7/13/2011 19:55'!
setUp
	super setUp.
	sixMinutes := 6 maMinutes.
	twoMinutes := 2 maMinutes.
	yesterday := MaCalendarTime
		date: '3/31/2011' asDate
		time: '4:00pm' asTime
		milliseconds: 0.
	today := MaCalendarTime
		date: '4/1/2011' asDate
		time: '5:00pm' asTime! !

!MaTimeObjectsTest methodsFor: 'tests' stamp: 'cmm 7/10/2011 23:15'!
testAccuracy
	| realNow testNow |
	realNow := DateAndTime now.
	testNow := realNow asMaCalendarTime.
	self
		 assert: realNow asSeconds = testNow totalSeconds ;
		 assert: realNow asDate = testNow asDateAndTime asDate ;
		 assert: realNow asTime = testNow asTime! !

!MaTimeObjectsTest methodsFor: 'tests' stamp: 'cmm 7/12/2011 21:24'!
testArithmetic
	self
		 assert: sixMinutes // 3 = twoMinutes ;
		 assert: twoMinutes*3 = sixMinutes ;
		 assert: sixMinutes // twoMinutes = 3 ;
		 assert: sixMinutes \\ 5 maMinutes = 1 maMinute ;
		 assert: sixMinutes + twoMinutes = 8 maMinutes ;
		 assert: sixMinutes - twoMinutes = 4 maMinutes ;
		 assert: (sixMinutes - sixMinutes) isZero ;
		 assert: today + twoMinutes = '2011-04-01T17:02:00.000' asMaCalendarTime ;
		 assert: today - twoMinutes = '2011-04-01T16:58:00.000' asMaCalendarTime ;
		 assert: (today + 37 maSeconds truncateTo: 1 maMinute) = today ;
		 assert: (today + 37 maSeconds roundTo: 1 maMinute) = (today + 1 maMinute) ;
		 assert: (sixMinutes + 37 maSeconds truncateTo: 1 maMinute) = sixMinutes ;
		 assert: (sixMinutes + 37 maSeconds roundTo: 1 maMinute) = (sixMinutes + 1 maMinute) ;
		 assert: (1 maDay + 2 maHours + 3 maMinutes + 4 maSeconds + 5 maMilliseconds) totalMilliseconds = (24 * 60 * 60 * 1000 + (2 * 60 * 60 * 1000) + (3 * 60 * 1000) + (4 * 1000) + 5)! !

!MaTimeObjectsTest methodsFor: 'tests' stamp: 'cmm 7/9/2011 16:14'!
testComparing
	self
		 assert: twoMinutes < sixMinutes ;
		 assert: sixMinutes > twoMinutes ;
		 assert: yesterday < today ;
		 deny: twoMinutes = sixMinutes ;
		 deny: yesterday = today! !

ClassTestCase subclass: #MaDateTest
	instanceVariableNames: 'date aDate aTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaDateTest methodsFor: 'Coverage' stamp: 'cmm 7/10/2011 22:53'!
classToBeTested
	^ MaDate! !

!MaDateTest methodsFor: 'Private' stamp: 'cmm 7/10/2011 22:40'!
dateClass
	^ Date! !

!MaDateTest methodsFor: 'Coverage' stamp: 'cmm 7/10/2011 22:52'!
selectorsToBeIgnored
	| deprecated private special |
	deprecated := #().
	private := #().
	special := #(#< #= #next #previous ).
	^ super selectorsToBeIgnored , deprecated , private , special! !

!MaDateTest methodsFor: 'Running' stamp: 'cmm 7/10/2011 23:15'!
setUp
	date := (Date
		newDay: 153
		year: 1973) asMaCalendarTime.
	aDate := (Date readFrom: '01-23-2004' readStream) asMaCalendarTime.
	aTime := Time readFrom: '12:34:56 pm' readStream! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:28'!
testAccessing
	self	
		assert: date dayOfYear = 153;
		assert: date month = 6;
		assert: date dayOfWeek = 7;
		assert: date year = 1973! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 23:30'!
testAddDays
	self assert: aDate + 0 maDays = '2004-01-23' asMaDate.
	self assert: aDate + 30 maDays = '2004-02-22' asMaDate.
	self assert: aDate + 60 maDays = '2004-03-23' asMaDate.
	self assert: aDate + 90 maDays = '2004-04-22' asMaDate.
	self assert: aDate + 120 maDays = '2004-05-22' asMaDate! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/10/2011 23:45'!
testArithmetic
	| d |
	d := date + 32 maDays.		"4 July 1973"

	self 
		assert: d year = 1973;
		assert: d month = 7;
		assert: d dayOfMonth = 4.
	self 
		assert: (d - date) = 32 maDays.
	self	 
		assert: (d - 32 maDays) = date.
! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testAsDate
	self assert: (aDate asDate) = aDate
! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 23:45'!
testAsSeconds
	self assert: (aDate totalSeconds) =   3252268800.
	self assert: (aDate totalSeconds) =  ((103*365*24*60*60) + (22+25"leap days"*24*60*60)) .
	self assert: aDate  =  (MaDate fromSeconds: 3252268800).! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/10/2011 22:55'!
testComparing
	| d1 d2 d3 |
	d1 := (self dateClass
		newDay: 2
		month: #June
		year: 1973) asMaCalendarTime.
	d2 := (self dateClass
		newDay: 97
		year: 2003) asMaCalendarTime.
	d3 := (self dateClass
		newDay: 250
		year: 1905) asMaCalendarTime.
	self
		 assert: date = d1 ;
		 assert: date = date copy ;
		 assert: date hash = d1 hash.
	self
		 assert: date < d2 ;
		 deny: date < d3! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/10/2011 23:50'!
testConverting

	self 
		assert: date asDate = date;
		assert: '2 June 1973' asMaDate = date;
		assert: date totalSeconds = 2285280000.

	date asDateAndTime dayMonthYearDo: [ :d :m :y | self assert: d = 2; assert: m = 6; assert: y = 1973 ].! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/10/2011 23:50'!
testConvertingFromIso8601

	self 
		assert: '1973-06-02' asMaDate = date;
		assert: '1973-JUN-02' asMaDate = date;
		assert: '1973-June-02' asMaDate = date! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testDateAndTimeNow
	"Not a great test: could falsely fail if midnight come in between the two executions and doesnt catch time errors"
	self assert: Date dateAndTimeNow first  = Date today 
! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testDaysInMonthForYear
	self assert: (Date daysInMonth: 'February' forYear: 2008)  = 29.	
	self assert: (Date daysInMonth: 'February' forYear: 2000)  = 29.	
	self assert: (Date daysInMonth: 'February' forYear: 2100)  = 28.	
	self assert: (Date daysInMonth: 'July' forYear: 2100)  = 31.	! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testDaysInYear
	self assert: (Date daysInYear: 2008)  = 366.	
	self assert: (Date daysInYear: 2000)  = 366.	
	self assert: (Date daysInYear: 2100)  = 365	
! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/11/2011 19:51'!
testDuration
	self assert: aDate duration = 24 maHours! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/11/2011 19:52'!
testEqual
	self assert: aDate = (Date readFrom: (ReadStream on: 'January 23, 2004')) asMaCalendarTime! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testFirstWeekdayOfMonthYear
	self assert: (Date firstWeekdayOfMonth: 'January' year: 2004)  = 5.	
! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 19:52'!
testFromDays
	| epoch d0 d1 |
	epoch := MaDate epoch.
	d0 := MaDate starting: 0 maDays. 			"1 January 1901"
	self assert: d0 = epoch.

	d1 := MaDate fromDays:  26450. 	"2 June 1973"
	self assert: d1 = date.

	self assert: aDate  =  (MaDate fromDays:  37642).
	self assert: aDate  =  (MaDate fromDays: 103*365 + 22 + 25 "leap days") .
! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/10/2011 23:02'!
testFromSeconds
	| d |
	d := MaDate fromSeconds: 2285280000. 
	self
		assert: d = date.
! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testIndexOfMonth
	self assert: (Date indexOfMonth: 'January')  = 1.	
	self assert: (Date indexOfMonth: 'December')  = 12.	! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/10/2011 23:12'!
testInitialization
	self should:
		[ MaCalendarTime initialize.
		true ]! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 20:04'!
testInquiries
	self
		 assert: date dayOfMonth = 2 ;
		 assert: date dayOfYear = 153 ;
		 assert: date daysInMonth = 30 ;
		 assert: date daysInYear = 365! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/13/2011 18:30'!
testLessThan
	self assert: aDate < (Date readFrom: (ReadStream on: '01-24-2004')) asMaCalendarTime! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testNameOfMonth
	self assert: (Date nameOfMonth: 5) = 'May'.	
	self assert: (Date nameOfMonth: 8) = 'August' ! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 20:07'!
testNew
	| epoch |
	epoch := (self dateClass newDay: 1 year: 1901) asMaCalendarTime.
	self assert: (MaDate new = epoch)! !

!MaDateTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 20:19'!
testPreviousNext
	| n p |
	n := date next.
	p := date previous.
	self
		assert: n year = 1973;
		assert: n dayOfYear = 154;
		assert: p year = 1973;
		assert: p dayOfYear = 152! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/11/2011 20:24'!
testStarting
	self assert: aDate = (MaDate starting: ('2004-01-23T12:12' asMaCalendarTime))! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/11/2011 20:37'!
testSubtractDate
	self assert: (aDate - (aDate - 0 maDays)) = 0 maDays.
	self assert: (aDate - (aDate - 30 maDays)) = 30 maDays! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/11/2011 20:38'!
testSubtractDays
	self assert: (aDate - 0 maDays) = '2004-01-23' asMaDate.
	self assert: (aDate - 30 maDays) = '2003-12-24' asMaDate.
	self assert: (aDate - 60 maDays) = '2003-11-24' asMaDate! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:39'!
testTomorrow
	self assert: Date tomorrow > Date today! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/11/2011 19:54'!
testWeekday
	self assert: aDate dayOfWeek = 6! !

!MaDateTest methodsFor: 'testing' stamp: 'cmm 7/10/2011 22:40'!
testYesterday
	self assert: Date yesterday < Date today! !

ClassTestCase subclass: #MaDurationTest
	instanceVariableNames: 'aDuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaDurationTest methodsFor: 'Coverage' stamp: 'cmm 7/12/2011 18:20'!
classToBeTested
	^ MaDuration! !

!MaDurationTest methodsFor: 'Coverage' stamp: 'cmm 7/12/2011 18:19'!
selectorsToBeIgnored

	| private | 
	private := #( #printOn: ).

	^ super selectorsToBeIgnored, private
! !

!MaDurationTest methodsFor: 'initializing' stamp: 'cmm 7/12/2011 18:21'!
setUp
	aDuration := 1 maDays + 2 maHours + 3 maMinutes + 4 maSeconds + 5 maMilliseconds! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:31'!
testAsMilliSeconds
	self assert: 1 maSecond totalMilliseconds = 1000.
	self assert: aDuration totalMilliseconds = 93784005! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 18:23'!
testComparing

	| d1 d2 d3 |
	d1 :=  10 maSeconds + 1 maMillisecond.
	d2 := 10 maSeconds + 1 maMillisecond.
	d3 := 10 maSeconds + 2 maMillisecond.
	
	self
		assert: (d1 = d1);
		assert: (d1 = d2);
		deny: (d1 = d3);
		assert: (d1 < d3)
! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/13/2011 18:19'!
testDivide
	self assert: aDuration // aDuration = 1.
	self assert: aDuration // 2 = (13 maHours + 1 maMinute + 32 maSeconds + 2 maMilliseconds)! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/15/2011 17:13'!
testHash
	self assert: aDuration hash = (1 maDays + 2 maHours + 3 maMinutes + 4 maSeconds + 5 maMilliseconds) hash.
	self
		 assert: 1 maMilliseconds hash = 1 hash ;
		 assert: (SmallInteger maxVal + 1) maMilliseconds hash = (SmallInteger maxVal + 1) hash ;
		 assert: 500 maMilliseconds hash = 500 hash ;
		 deny: 1 maSecond hash = 1 maDay hash! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 19:38'!
testLessThan
	self assert: aDuration < (aDuration + 1 maDay).
	self deny: aDuration < aDuration! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/13/2011 18:20'!
testMinus
	| yesterday |
	self assert: aDuration - aDuration = 0 maSeconds.
	self assert: aDuration - (1 maHours + 2 maMinutes + 3 maSeconds + 4 maMilliseconds) = (1 maDay + 1 maHour + 1 maMinute + 1 maSecond + 1 maMillisecond).
	self assert: aDuration - (3 maHours + 5 maSeconds) = (23 maHours + 2 maMinutes + 59 maSeconds + 5 maMilliseconds).
	yesterday := MaCalendarTime now - 1 maDay.
	self
		 assert: yesterday class = MaCalendarTime ;
		 assert: (3 maHours - 60 maMinutes) class = MaDuration ;
		 assert: (MaCalendarTime now - yesterday) class = MaDuration! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/13/2011 18:21'!
testModulo
	| d1 d2 d3 |
	d1 := 11.5 maSeconds.
	d2 := d1 \\ 3 maMilliseconds.
	self assert: d2 = 1 maMillisecond.
	d3 := d1 \\ 3 maSeconds.
	self assert: d3 = (2 maSeconds + 500 maMilliseconds).
	self assert: aDuration \\ aDuration = 0 maMilliseconds.
	self assert: aDuration \\ 2 maMilliseconds = 1 maMillisecond! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 19:44'!
testMultiply
	self assert: aDuration * 2 = (2 maDays + 4 maHours + 6 maMinutes + 8 maSeconds + 10 maMilliseconds)! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 19:48'!
testNew
	self assert:
		(Set
			with: MaDuration new
			with: (MaDuration fromMilliseconds: 0)
			with: MaDuration epoch
			with: 0 maMinutes) size = 1! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:20'!
testPlus
	self assert: aDuration + 0 maHours = aDuration.
	self assert: aDuration + aDuration = (2 maDays + 4 maHours + 6 maMinutes + 8 maSeconds + 10 maMilliseconds)! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 21:23'!
testQuotient
	| d1 d2 q |
	d1 := 11.5 maSeconds.
	d2 := d1 // 3.
	self assert: d2 = (3 maSeconds + 833 maMilliseconds).
	q := d1 // 3 maSeconds.
	self assert: q = 3! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 18:33'!
testRoundTo
	self assert: (5 maMinutes + 37 maSeconds roundTo: 2 maMinutes) = 6 maMinutes.
	self assert: (aDuration roundTo: 1 maDay) = 1 maDay.
	self assert: (aDuration roundTo: 1 maHour) = (1 maDay + 2 maHours).
	self assert: (aDuration roundTo: 1 maMinute) = (1 maDay + 2 maHours + 3 maMinutes)! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:25'!
testSeconds
	self assert: aDuration second = 4.
	self assert: 2 maMilliseconds second = 0.
	self assert: 999 maMilliseconds second = 0.
	self assert: 1000 maMilliseconds second = 1.
	self assert: (1 maDay + 2 maHours + 3 maMinutes + 4 maSeconds) second = 4.
	self deny: (1 maDays + 2 maHours + 3 maMinutes + 4 maSeconds) second = (1 * 24 * 60 * 60 + (2 * 60 * 60) + (3 * 60) + 4)! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 18:35'!
testTruncateTo
	self assert: (5 maMinutes + 37 maSeconds truncateTo: 2 maMinutes) = 4 maMinutes.
	self assert: (aDuration truncateTo: 1 maDay) = 1 maDay.
	self assert: (aDuration truncateTo: 1 maHour) = (1 maDay + 2 maHours).
	self assert: (aDuration truncateTo: 1 maMinute) = (1 maDay + 2 maHours + 3 maMinutes)! !

!MaDurationTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:26'!
testZero
	self assert: MaDuration zero = (MaDuration fromMilliseconds: 0)! !

ClassTestCase subclass: #MaMonthTest
	instanceVariableNames: 'month'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaMonthTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Month.
!

!MaMonthTest methodsFor: 'Coverage' stamp: 'cmm 7/11/2011 22:07'!
classToBeTested
	^ MaMonth! !

!MaMonthTest methodsFor: 'Coverage' stamp: 'cmm 7/11/2011 22:06'!
selectorsToBeIgnored

	| deprecated private special |
	deprecated := #().
	private := #( #printOn: ).
	special := #( #next ).

	^ super selectorsToBeIgnored, deprecated, private, special.! !

!MaMonthTest methodsFor: 'Running' stamp: 'cmm 7/11/2011 22:06'!
setUp
	super setUp.
	month := MaMonth
		month: 7
		year: 1998! !

!MaMonthTest methodsFor: 'Running' stamp: 'cmm 7/11/2011 22:06'!
tearDown

	super tearDown.
	month := nil.! !

!MaMonthTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:08'!
testConverting

	self assert: month asDate = '1 July 1998' asMaDate! !

!MaMonthTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:16'!
testEnumerating
	| weeks |
	weeks := OrderedCollection new.
	month weeksDo: [ :w | weeks add: w start ].
	0 to: 4 do: [ :i | weeks remove: (MaWeek starting:  ('29 June 1998' asMaDate + (i * 7) maDays)) start ].
	self assert: weeks isEmpty! !

!MaMonthTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:10'!
testInquiries
	self
		 assert: month month = 7 ;
		 assert: month monthName = #July ;
		 assert: month duration = 31 maDays! !

!MaMonthTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:11'!
testInstanceCreation
	| m1 m2 |
	m1 := MaMonth starting:  '4 July 1998' asMaDate.
	m2 := MaMonth month: #July year: 1998.
	self
		assert: month = m1;
		assert: month = m2! !

!MaMonthTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:17'!
testPreviousNext
	| n p |
	n := month next.
	p := month previous.

	self
		assert: n year = 1998;
		assert: n month = 8;
		assert: p year = 1998;
		assert: p month = 6.

! !

!MaMonthTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:21'!
testPrinting
	self assert: month printString = 'a MaMonth July 1998'! !

ClassTestCase subclass: #MaStopwatchTest
	instanceVariableNames: 'aStopwatch aDelay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaStopwatchTest methodsFor: 'Coverage' stamp: 'cmm 7/12/2011 20:49'!
classToBeTested
	^ MaStopwatch! !

!MaStopwatchTest methodsFor: 'Coverage' stamp: 'cmm 7/12/2011 20:44'!
selectorsToBeIgnored

	| private | 
	private := #( #printOn: #state: ).

	^ super selectorsToBeIgnored, private
! !

!MaStopwatchTest methodsFor: 'running' stamp: 'cmm 7/12/2011 20:47'!
setUp
	aStopwatch := MaStopwatch new.
	aDelay := Delay forMilliseconds: 1.! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:53'!
testActive
	| sw |
	sw := MaStopwatch new.
	sw start.
	1 seconds asDelay wait.
	self assert: sw time >= 1 maSeconds.
	2 seconds asDelay wait.
	self assert: sw time >= 3 maSeconds.
	sw stop! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 22:06'!
testChangingStatus
	aStopwatch start.
	self assert: aStopwatch isRunning..
	500 milliseconds asDelay wait.
	self deny: aStopwatch time isZero.
	aStopwatch stop.
	self assert: aStopwatch isStopped.
	self deny: aStopwatch time isZero.
	aStopwatch start.
	self assert: aStopwatch isRunning.
	self assert: aStopwatch time > 0 maSeconds.
	aStopwatch reset.
	self assert: aStopwatch isStopped.
	self assert: aStopwatch time isZero! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 22:07'!
testInitialStatus
	self assert: aStopwatch isStopped.
	self deny: aStopwatch isRunning.
	self assert: aStopwatch time = 0 maSeconds! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:55'!
testNew
	| sw |
	sw := MaStopwatch new.
	self
		 assert: sw isStopped ;
		 deny: sw isRunning ;
		 assert: sw time = 0 maSeconds! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:56'!
testReset
	| sw |
	sw := MaStopwatch new.
	sw start.
	sw reset.
	self
		 assert: sw isStopped ;
		 assert: sw time = 0 maSeconds! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 20:56'!
testRestart
	| sw |
	sw := MaStopwatch new.
	sw
		 start ;
		 stop ;
		 start.
	self assert: sw isRunning! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 22:14'!
testSingleTiming
	"See if the stopwatch is accurate to 1-millisecond."
	| timeBefore |
	timeBefore := MaCalendarTime now.
	aStopwatch start.
	aDelay wait.
	aStopwatch stop.
	self
		 assert: aStopwatch startTime + aStopwatch time >= timeBefore ;
		 assert: aStopwatch totalStoppedTime = 0 maSeconds! !

!MaStopwatchTest methodsFor: 'Tests' stamp: 'cmm 7/12/2011 22:17'!
testStartStop
	| sw t1 t2 t3 t4 |
	sw := MaStopwatch new.
	t1 := MaCalendarTime now.
	(Delay forMilliseconds: 10) wait.
	sw
		 start ;
		 start.
	(Delay forMilliseconds: 10) wait.
	t2 := MaCalendarTime now.
	self
		 deny: sw isStopped ;
		 assert: sw isRunning ;
		 assert: t1 <= sw startTime ;
		 assert: sw startTime <= t2.
	(Delay forMilliseconds: 10) wait.
	t3 := MaCalendarTime now.
	(Delay forMilliseconds: 10) wait.
	sw
		 stop ;
		 stop.
	(Delay forMilliseconds: 10) wait.
	t4 := MaCalendarTime now.
	self
		 assert: sw isStopped ;
		 deny: sw isRunning ;
		 assert:
		(sw stoppedTime
			between: t3
			and: t4) ;
		 assert: t3 <= sw stoppedTime ;
		 assert: sw stoppedTime <= t4! !

ClassTestCase subclass: #MaWeekTest
	instanceVariableNames: 'week restoredStartDay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaWeekTest methodsFor: 'Coverage' stamp: 'cmm 7/11/2011 21:56'!
classToBeTested
	^ MaWeek! !

!MaWeekTest methodsFor: 'Coverage' stamp: 'cmm 7/11/2011 21:52'!
selectorsToBeIgnored

	| deprecated private special |

	deprecated := #().
	private := #( #printOn: ).
	special := #( #next #do: ).

	^ super selectorsToBeIgnored, deprecated, private, special.! !

!MaWeekTest methodsFor: 'Running' stamp: 'cmm 7/11/2011 21:54'!
setUp
	"June 1998, 5th week"
	super setUp.
	week := MaWeek starting: '4 July 1998' asMaDate


! !

!MaWeekTest methodsFor: 'Running' stamp: 'cmm 7/11/2011 21:54'!
tearDown
	super tearDown.
	week := nil! !

!MaWeekTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:03'!
testEnumerating
	| days |
	days := OrderedCollection new.
	0
		to: 6
		do:
			[ : i | days add: '28 June 1998' asMaDate + i maDays ].
	week datesDo:
		[ : d | days remove: d ].
	self assert: days isEmpty! !

!MaWeekTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:03'!
testInquiries
	self
		 assert: week start asDate = '28 June 1998' asMaDate ;
		 assert: week end asDate = '4 July 1998' asMaDate ;
		 assert: week duration = 7 maDays! !

!MaWeekTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:03'!
testPreviousNext
	self
		assert: week next = (MaWeek starting: '6 July 1998' asMaDate);
		assert: week previous = (MaWeek starting:  '22 June 1998' asMaDate)! !

ClassTestCase subclass: #MaYearTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma time objects-Tests'!

!MaYearTest methodsFor: 'Coverage' stamp: 'cmm 7/11/2011 22:24'!
classToBeTested

	^ Year! !

!MaYearTest methodsFor: 'Tests' stamp: 'cmm 7/11/2011 22:25'!
testCurrent
	| yyyy |
	yyyy := MaCalendarTime now year.
	self assert:
		MaYear now start =
			(DateAndTime
				year: yyyy
				month: 1
				day: 1) asMaCalendarTime! !
MaCalendarTime initialize!
